# List

Launch stage: GA

`GET /api/2.0/pipelines`

Lists pipelines defined in the Spark Declarative Pipelines system.

API scopes: pipelines

## Query parameters

- `page_token` (string, optional)
  Page token returned by previous call
- `max_results` (int32, optional)
  The maximum number of entries to return in a single page. The system may
   return fewer than max_results events in a response, even if there are
   more events available. This field is optional. The default value is 25.
   The maximum value is 100. An error is returned if the value of max_results
   is greater than 100.
  Default: `25`
  Constraints: `<= 100`
- `order_by` (array of string, optional)
  A list of strings specifying the order of results.
   Supported order_by fields are id and name. The default is id asc.
   This field is optional.
- `filter` (string, optional)
  Select a subset of results based on the specified criteria.
   The supported filters are:
  
   * `notebook='<path>'` to select pipelines that reference the provided notebook path.
   * `name LIKE '[pattern]'` to select pipelines with a name that matches pattern.
     Wildcards are supported, for example: `name LIKE '%shopping%'`
  
   Composite filters are not supported. This field is optional.

## Returns

- `statuses` (array of object, optional)
  The list of events matching the request criteria.
  - `pipeline_id` (string, optional)
    The unique identifier of the pipeline.
  - `state` (string, optional)
    Possible values: `DEPLOYING`, `STARTING`, `RUNNING`, `STOPPING`, `DELETED`, `RECOVERING`, `FAILED`, `RESETTING`, `IDLE`
  - `cluster_id` (string, optional)
    The unique identifier of the cluster running the pipeline.
  - `name` (string, optional)
    The user-friendly name of the pipeline.
  - `latest_updates` (array of object, optional)
    Status of the latest updates for the pipeline. Ordered with the newest update first.
    - `update_id` (string, optional)
    - `state` (string, optional)
      Possible values: `QUEUED`, `CREATED`, `WAITING_FOR_RESOURCES`, `INITIALIZING`, `RESETTING`, `SETTING_UP_TABLES`, `RUNNING`, `STOPPING`, `COMPLETED`, `FAILED`, `CANCELED`
    - `creation_time` (string, optional)
  - `creator_user_name` (string, optional)
    The username of the pipeline creator.
  - `run_as_user_name` (string, optional)
    The username that the pipeline runs as. This is a read only value derived from the pipeline owner.
  - `health` (string, optional)
    The health of a pipeline.
    Possible values: `HEALTHY`, `UNHEALTHY`
- `next_page_token` (string, optional)
  If present, a token to fetch the next page of events.

## Response

```json
{
  "next_page_token": "eyJ...==",
  "prev_page_token": "eyJ..x9",
  "statuses": [
    {
      "creator_user_name": "username",
      "latest_updates": [
        {
          "creation_time": "2021-08-13T00:34:21.871Z",
          "state": "COMPLETED",
          "update_id": "ee9ae73e-fc61-11eb-9a03-0242ac130003"
        }
      ],
      "name": "SDP quickstart (Python)",
      "pipeline_id": "e0f01758-fc61-11eb-9a03-0242ac130003",
      "state": "IDLE"
    },
    {
      "creator_user_name": "username",
      "name": "My SDP quickstart example",
      "pipeline_id": "f4c82f5e-fc61-11eb-9a03-0242ac130003",
      "state": "IDLE"
    }
  ]
}
```

